<template>
	<view v-if="allShow">
		<!--pages/detail/detail.wxml-->
		<view class="banner">
			<swiper class="swiper" @change="swiperChange" :current="current" autoplay="true" circular="true"
				duration="1000">
				<block v-for="(item, index) in product.images" :key="index">
					<swiper-item autoplay="true">
						<image :src="item + '?x-oss-process=style/w750-auto'" mode="aspectFit"></image>
					</swiper-item>
				</block>
			</swiper>
			<view class="dots dflex">
				<block v-for="(item, index) in product.images" :key="index">
					<view :class="'dot ' + (index == swiperCurrent ? ' active' : '')" :data-current="index"
						@tap="dotEvent"></view>
				</block>
			</view>
		</view>
		<!-- <view bindtap="saoma">扫码</view> -->
		<!-- <view class="notification_bar" wx:if="{{isNotice}}">
	<swiper class="swiper_container" vertical="true" autoplay="true" circular="false" duration="1000" interval="5000" easing-function="easeInOutCubic" class="bar_box dflex">
		<swiper-item class="bar_con dflex" wx:for="{{contentList}}" wx:key="item">
			<view class="bar dflex">
				<image class="bar_left" src="{{item.pic}}" />
				<text class="bar_text">最新订单来自</text>
				<text class="bar_text">{{item.name}}，</text>
				<text class="bar_text">{{item.time}}</text>
			</view>
		</swiper-item>
	</swiper>
</view> -->
		<view class="info bgfff">
			<view class="infos dflex">
				<view class="price dflex">
					￥<text>{{product.salePrice?product.salePrice:'0'}}</text>
					<text class="origin"
						v-if="product.salePrice == product.actualPrice && product.marketPrice > 0&&product.salePrice<product.marketPrice">￥{{product.marketPrice}}</text>
					<!-- <view class="hyprice dflex" bindtap="govip"
				wx:if="{{show_membership_price==1&&product.membersPrice<product.salePrice&&product.membersPrice!=null}}">
				<text>￥{{product.membersPrice}}</text>
				<view class="hytxt">
					<image src="/pages/images/hybg.png"></image>
					<text>会员价</text>
				</view>
			</view> -->
					<!-- <view class="hyjiage" v-if="product.actualPrice<product.salePrice&&show_membership_price==1">
						<image src="/product/static/product/image/hy.png" class="hyimg"></image>
						￥{{product.actualPrice}}
					</view> -->
				</view>
				<!-- <view class="price dflex" wx:if="{{product.mode==2}}">
			<text>{{product.integral}}积分</text>
			<text class="money">+￥{{product.salePrice}}</text>
			<text class="origin"
				wx:if="{{product.salePrice == product.actualPrice && product.marketPrice > 0}}">￥{{product.marketPrice}}</text>
			<view class="hyprice dflex" wx:if="{{product.salePrice != product.actualPrice && product.actualPrice>0}}">
				<text>￥{{product.actualPrice}}</text>
				<view class="hytxt">
					<image src="/pages/images/hybg.png"></image>
					<text>专享价</text>
				</view>
			</view>
		</view> -->
				<view class=" sellStock" v-if="product.sellStock>0">销量：<text>{{product.sellStock}}</text></view>
				<view class="share" @tap="showShare">
					<image src="/static/pages/images/fxico.png"></image>分享
				</view>
			</view>
			<view class="huiyuan" @tap="govip"
				v-if="show_membership_price==1&&product.membersPrice!=null"><!-- &&product.membersPrice<product.salePrice -->
				<view class="dflex huiyuanjia">
					<view class="dflex">
						
						<!-- <image src="/product/static/product/image/huiyuanjia.png" class="huiyuanimg"></image> -->
						{{userInfo.level && userInfo.level != 'LV0' ? userInfo.level : '会员价'}}
						<text class="hymoney">￥{{product.actualPrice < product.salePrice ? product.actualPrice : product.membersPrice}}</text>
						立省￥{{product.jianMoney?product.jianMoney:'0'}}
					</view>
					<view class="d-open" v-if="!userInfo.level">立即开通</view>
					<image src="/product/static/product/image/govip.png" class="govipimg" v-else></image>
				</view>
			</view>
			<view class="title">
				<image src="/static/pages/images/jishida.png" class="tag" v-if="product.isJs&&merchant.type!=5&& about.timely_close != 1">
				</image>
				<image src="/product/static/product/image/overseasPurchase.png" class="tag" v-if="product.isOtc===5">
				</image>
				<text class="yushou" v-if="product.estimatedDeliveryTimeStr">预售</text>{{product.title?product.title:''}}
			</view>
			<view class="protext">
				{{product.brandName ? product.brandName : ''}} {{product.brief ?  product.brief : ''}}
			</view>
			<view class="guarantee dflex" v-if="guarantee.length>0">
				<view class="cont dflex">
					<view v-for="(item, index) in guarantee" :key="index" class="dflex li">
						<image src="/product/static/product/image/guarantee.png"></image>{{item}}
					</view>
				</view>
			</view>
			<!-- isOtc 0 默认 1 处方药 2 非处方药 3 医疗器械 4 食品类 5 海外购 -->
			<block v-if="product.isOtc!=5">
				<block v-if="is_open_shop == 1 && ascription">
					<view class="xiaodian dflex malr20"
						v-if="((product.isMeCommission != 1 || product.isMeCommission != '1') && product.oneCommission>0) || ((product.isMeCommission == 1 || product.isMeCommission == '1') && product.twoCommission>0) || product.serviceShopRate">
						<image src="/static/pages/images/xdbg1.png" class="xdbg"></image>
						<view class="shouyi flex"
							v-if="((product.isMeCommission != 1 || product.isMeCommission != '1') && product.oneCommission>0) || ((product.isMeCommission == 1 || product.isMeCommission == '1') && product.twoCommission>0)">
							<text>预计分销收益</text>
							<view v-if="product.isMeCommission == 0"><text>￥</text>{{product.oneCommission}}</view>
							<view v-else><text>￥</text>{{product.twoCommission}}</view>
						</view>
						<view class="shouyi flex" v-if="product.serviceShopRate">
							<text>预计小店服务费</text>
							<view><text>￥</text>{{product.serviceShopRate}}</view>
						</view>
						<view class="dflex" v-if="product.isJoinShop">
							<view class="fenxiang" @tap="showShare">分享推广</view>
							<navigator :url="url" hover-class="none" class="goShop">去小店</navigator>
						</view>
						<view class="addshop" @tap="addShop" v-else>添加到小店</view>
					</view>
				</block>
				<block v-else>
					<view class="xiaodian dflex malr20"
						v-if="((product.isMeCommission != 1 || product.isMeCommission != '1') && product.oneCommission>0) || ((product.isMeCommission == 1 || product.isMeCommission == '1') && product.twoCommission>0)">
						<image src="/static/pages/images/xdbg1.png" class="xdbg"></image>
						<view class="shouyi flex">
							<text>预计分销收益</text>
							<view v-if="product.isMeCommission == 0"><text>￥</text>{{product.oneCommission}}</view>
							<view v-else><text>￥</text>{{product.twoCommission}}</view>
						</view>
						<navigator url="/promote/apply/apply" hover-class="none" class="fenxiang"
							v-if="isDistriUser != 2">我要推广</navigator>
						<view class="fenxiang" @tap="showShare" v-else>分享推广</view>
					</view>
				</block>
			</block>
		</view>

		<view class="detinfo mt20 bgfff">
			<!-- <view class="item dflex" @tap="onActive">
				<label>活动</label>
				<view class="acti quan flex">
					<block>
						<view class="huodong  dflex">
							<text>多买优惠</text>
							满2件，总价打75折
						</view>
						<view class=" dflex">
							<text>拼团</text>
							此商品正常参加拼团购
						</view>
					</block>
				</view>
				<image src="/static/pages/images/more2.png" class="more" @tap="onActive"></image>
			</view> -->
			<view class="item dflex" v-if="couponList&&couponList.length>0">
				<label>优惠券</label>
				<view class="quan flex dflex" @click="jumpUrl('/product/couponList/index?productId=' + query.id)">
					<view class="flex dflex coupon-list">
						<text v-for="(item,index) in couponList" :key="index" v-if="index < 3">{{item.couponTitle}}</text>
					</view>
					<view class="ling dflex">领券<image src="/static/pages/images/more3.png"></image>
					</view>
				</view>
			</view>
			<view class="item pro-sel dflex" v-if="product.propertiesList && product.propertiesList.length > 0"
				@click="product.stock > 0 ? addShopCart() : ''">
				<label>已选</label>
				<view class="flex">{{product.properties}}</view>
				<image src="/static/pages/images/more.png" class="mrico"></image>
			</view>
			<view class="item pro-time dflex" v-if="product.estimatedDeliveryTimeStr">
				<label>预计发货时间</label>
				<view class="flex">{{product.estimatedDeliveryTimeStr}} 前发货</view>
			</view>
			<view class="item dflex">
				<label>配送至</label>
				<view class="flex" @tap="toAddress">
					<view class="address">{{address.address?address.address:''}}{{address.house?address.house:''}}
					</view>
					<view class="huo">
						<!-- <text>现货</text> -->
						<text v-for="(item, index) in tabe" :key="index" v-if="tabe.length>0">{{item}}</text>
						<!-- 现在下单，预计2小时后送达 -->
					</view>
				</view>
				<image src="/static/pages/images/more2.png" class="more" @tap="toAddress"></image>
			</view>


			<view class="item dflex" v-if="merchant.isDefault!=1">
				<label>当前门店</label>
				<view class="flex" @tap="updateShop">
					<view class="address">{{merchant.title}}</view>
				</view>
				<image src="/static/pages/images/more2.png" class="more" @tap="updateShop"></image>
			</view>
			<navigator :url="'/product/supplier/supplier?id=' + product.supplierModel.id" hover-class="none" class="item det-sup dflex" v-if="about.is_show_supplier == 1 && product.supplierModel">
				<label>供应商</label>
				<view class="flex">
					<view class="dflex">
						<view class="sup-name flex tover">{{product.supplierModel.name}}</view>
						<image src="/static/pages/images/more.png" class="mrico"></image>
					</view>
					<view class="sup-bri tover" v-if="product.supplierModel.businessScope">主营范围：{{product.supplierModel.businessScope}}</view>
				</view>
			</navigator>
		</view>
		<!-- 海外购 -->
		<!-- <view class="detinfo mt20 bgfff" wx:if="{{product.isOtc==5}}">
	<view class="item">
		<view class="dflex">
			<label>物流</label>
			<view class="">
				<view class="address">20：00前付款，预计  9月30日前送达</view>
			</view>
		</view>
		<view class="dflex logistics">
			<view class="lsicText">
				<image src="/product/image/abroad.png" class="abroad"></image>
				德国进口
			</view>
			<image src="/product/image/you_h.png" class="you"></image>
			<view class="lsicText">
				<image src="/product/image/bonded.png" class="abroad"></image>
				保税店
			</view>
			<image src="/product/image/you.png" class="you"></image>
			<view>
				<image src="/product/image/position.png" class="abroad"></image>
				长沙市
			</view>
		</view>
	</view>
</view> -->
		<!--  商品详情等页面 -->
		<product-footer ref="list" id="list" :detail="nodes" :imgs="imgs" :proId="product.id" :form="form"
			@scoreTab="scoreTab" @showTab="showTab" v-if="product.id" @freshen="freshenFun" @getForm="getForm">
		</product-footer>


		<v-share :hide-toast="hideShare" :product="product" :code-url="codeUrl" @onFather="click"></v-share>
		<view class="placeholder-view" :style="'height:' + (bottomBlankHeight + 140) + 'rpx'"></view>
		<view class="bot fixed bgfff dflex" :style="'padding-bottom: ' + (bottomBlankHeight + 20) + 'rpx'">
			<view class="btnfot">
				<navigator class="botbtn" open-type="switchTab" url="/pages/index/index" hover-class="none">
					<image src="/static/pages/images/sy.png"></image>首页
				</navigator>
				<navigator class="botbtn" open-type="switchTab" url="/pages/cart/cart" hover-class="none">
					<image src="/static/pages/images/gwc.png"></image>购物车<text class="message"
						v-if="product.count > 0">{{product.count}}</text>
				</navigator>
				<view class="botbtn" @tap="clickCollect">
					<image src="/static/pages/images/shoucang_h.png" v-if="product.isCollect"></image>
					<image src="/static/pages/images/shoucang.png" v-else></image>收藏
				</view>
			</view>
			<view class="btnbuy">
				<view :class="['addcart',product.stock >= 1 && product.state == 1&&product.salePrice>0 ? '' : 'gray']"
					@tap="product.stock >= 1 && product.state == 1&&product.salePrice>0 ? addShopCart() : ''">加入购物车
				</view>
				<view class="gmbtn mbglinear" @tap="atOnceBuy"
					v-if="product.stock >= 1 && product.state == 1&&product.salePrice>0">
					{{product.isOtc==1 ?'预约下单': '立即购买'}}
				</view>
				<view class="gmbtn mbggray" v-if="(product.stock < 1)&&load">已售罄</view>
				<block v-else>
				<view class="gmbtn mbggray" v-if="(product.state != 1||!product.salePrice)&&load">已下架</view>
				</block>
				<view class="gmbtn mbggray" v-if="product.stock < 1 && product.state == 1&&product.salePrice>0">立即购买
				</view>
			</view>
		</view>
		<view class="xiajia" v-if="product.stock < 1">您来晚了，商品已售罄</view>
		<block v-else>
		<view class="xiajia" v-if="(product.state !=1 ||!product.salePrice) &&load">您来晚了，商品已经下架</view>
		</block>

		<!-- 商品规格 -->
		<block v-if="isShow">
			<product-popup :product="popup" :order-type="1" :is-cart="isCart" :is-timely="product.isTimely"
				:merchant="merchant" :merchant-id="merchantId" @hidePopup="hidePopup" @addCartSuccess="addCartSuccess"
				:index="index" :shopId="query.shopId" @freshen="changeFreshen" @getPor="getPor">
			</product-popup>
		</block>
		<!-- 返回顶部 -->
		<contact-button img-url="/static/pages/images/kfico1_1.png" class-name="side-contact" button-text="客服"></contact-button>
		<view class="contact_index" @tap="goTop">
			<image src="/static/pages/images/backtop.png"></image>顶部
		</view>
		<!-- 添加到小店成功 -->
		<view class="mask" :hidden="isHide" @tap="hidePop"></view>
		<view class="suc" :hidden="isHide">
			<image src="/static/pages/images/tjcg1.png" class="tjcg1"></image>
			<image src="/static/pages/images/tjcg.png" class="tjcg"></image>
			<text>快去我的小店看看吧</text>
			<view class="shopcc dflex">
				<view class="shop" @tap="showShare">分享推广</view>
				<navigator :url="url" hover-class="none" class="shop">我的小店</navigator>
			</view>
			<!-- <view class="share-btn dflex">
				<button class="wxfriend dflex" open-type="share">
					<image src="/static/pages/images/wechat.png"></image>
					微信好友
				</button>
				<view class="wxposter dflex" @tap="generatePoster">
					<image src="/static/pages/images/poster.png"></image>
					生成海报
				</view>
			</view> -->
			<image src="/static/pages/images/close2.png" class="suc-close" @tap="hidePop"></image>
		</view>
		<block v-if="isActive">
			<product-acitvity @hideActive="hideActive"></product-acitvity>
		</block>
		<block v-if="isPopupLogin">
			<product-login :about="about" @hidePopupLogin="hidePopupLogin"></product-login>
		</block>
		<!-- 订单购买轮播 -->
		<view :class="(marqueeOrderItem ? 'roll-notice ' : '') + 'dflex'" v-if="marqueeOrderItem">
			<image :src="marqueeOrderItem.avatar"></image>
			<view class="flex">{{ marqueeOrderItem.time }} 购买了{{ marqueeOrderItem.productName }}</view>
		</view>
		<update-userinfo :update-info="isUpdateInfo" :update-mobile="isUpdateMobile" v-if="isShowUpdate" @closeUpdate="closeUpdate" @updateInfo="updateInfo" @updateMobile="updateMobile"></update-userinfo>
	</view>
</template>

<script>
	const app = getApp();
	const req = require("../../utils/request.js");
	const utils = require("../../utils/util.js");
	var QQMapWX = require("../../utils/qqmap.js");
	const route = require("../../utils/route");
	const api = require("../../utils/api.js");
	import productFooter from "../../components/product_footer/index";
	import productPopup from "../../components/product-popup/index";
	import vShare from "../../components/share/share";
	import productAcitvity from "../../components/product-activity/index";
	import productLogin from "../../components/product-login/index";

	export default {
		data() {
			return {
				bottomBlankHeight: app.globalData.isIPhoneX ? 68 : 0,
				swiperCurrent: 0,
				bannerUrls: [],
				isShow: false,
				pro: {},
				isCart: false,
				timer: [],
				hideShare: true,
				codeUrl: '',
				form: {
					page: 1,
					limit: 10
				},
				contentList: [{
					pic: "/static/pages/images/bar.png",
					name: '好风依旧',
					time: '4秒前'
				}, {
					pic: "/static/pages/images/bar.png",
					name: '杨鑫',
					time: '20秒前'
				}, {
					pic: "/static/pages/images/bar.png",
					name: '杨鑫',
					time: '5秒前'
				}],
				isNotice: false,
				hideShop: true,
				//隐藏添加到小店
				isHide: true,
				//添加小店成功弹窗
				url: '/mine/shop/shop',
				freshen: true,
				//是否更新页面
				isActive: false,
				current: "",
				query: "",
				merchantId: "",
				merchant: "",
				userInfo: "",
				ascription: false, //是否开启小店
				guarantee: "",
				show_membership_price: "",
				Is_Store_Price_Stock: "",
				is_open_shop: "",
				is_open_comments: "",
				shopId: "",
				params: "",
				product: "",
				nodes: "",
				imgs: [],
				tabe: "",
				load: false,
				address: {},
				index: "",
				popup: "",
				tabIndex: "",
				switch: true,
				about: {},
				allShow: false,
				isDistriUser: 0, // 判断用户是否是分销员 2为分销员
				isPopupLogin: false,
				marqueeOrderItemIndex: 0,
				marqueeOrderItem: '',
				isShowTime: false,
				couponList: [],
				isVideoScene: false,//立即购买是否需要登录
				isShowUpdate: false,//是否显示更新信息弹窗
				isUpdateInfo: false,//更新用户信息
				isUpdateMobile: false,//绑定手机号
			};
		},

		components: {
			productFooter,
			productPopup,
			vShare,
			productAcitvity,
			productLogin
		},
		props: {},
		onLoad: function(options) {
			let that = this;
			// console.log(options);
			this.query = options;
			this.setData({
				query: options
			});

			if (options.scene) {
				this.scene = options.scene;
				this.merchantId = options.merchantId;
			}

			if (options.merchantId) {
				that.setData({
					merchantId: options.merchantId
				});
			}

			if (options.isShare || options.isShareTimeline) {
				req.setStorage('pidCode', options.userId);
				let params = {
					userId: options.userId,
					merchantId: options.merchantId ? options.merchantId : '',
				}
				this.bindUser(params);
			}
			
			if (options.hideShop) {
				this.setData({
					hideShop: false
				});
			} // if (options.merchantId && options.merchantId != 'undefined') {
			//   req.getRequest('/api/merchant/detail', { id: options.merchantId }, data => {
			//     req.setStorage("MERCHANT", data)
			//     that.setData({ merchant: data })
			//     console.log(data, "执行+++++++++++++++++++++")
			//   })
			// } else {
			//   let merchant = req.getStorage('MERCHANT');
			//   this.setData({ merchant: merchant });
			// }
			// else{
			//   // req.getRequest('/api/merchant/getMerchantList',{}, res => {
			//   //  res = res.filter(it=>it.isDefault==1)
			//   //   req.setStorage('MERCHANT', res[0]);
			//   //   this.data.merchant=res[0]
			//   //   that.setData({merchant:res[0]})
			//   //   console.log(this.data.merchant)
			//   // })
			//   let merchant=req.getStorage('MERCHANT')
			//   that.setData({merchant:merchant})
			// }
			this.isShop()

			setInterval(() => {
				this.setData({
					isNotice: true
				});
			}, 10000);
		},
		onShow: async function() {
			if(req.getStorage('isVideoScene') && (req.getStorage('scene') == 1176 || req.getStorage('scene') == 1177 || req.getStorage('scene') == 1195)){
				this.isVideoScene = true
			}
			if (this.freshen) {
				let that = this;
				await this.loadCodeParams();
				if (that.scene) {
					await that.bindUser(that.params);
				}
				this.getGuarantee().then(data => {
					// console.log("debug1", data);
					if (this.switch) {
						this.getMerchant()
					}
				})
				await this.getProductCoupon()
				// if (this.switch) {
				// 	this.getMerchant()
				// }
				await this.browsRecound(this.query.id);
			}
			this.getBuyOrderMarquee(!this.isShowTime);
		},
		onShareAppMessage: function(options) {
			// console.log(options);
			let merchantId = '';
			let path = '/product/detail/detail?id=' + this.query.id + '&isShare=' + true;
			// console.log(!req.getStorage('userInfo').id);

			if (!req.getStorage('userInfo').id) {} else {
				path += '&userId=' + req.getStorage('userInfo').id;
			}

			// console.log(this.query.merchantId);
			let shopId = '';
			if (req.getStorage('MERCHANT') && req.getStorage('MERCHANT').id != null) {
				path += '&merchantId=' + req.getStorage('MERCHANT').id;
				merchantId = req.getStorage('MERCHANT').id;

				if (req.getStorage('smallShop') && req.getStorage('MERCHANT').id != null) {
					path += '&shopId=' + req.getStorage('smallShop').id;
					shopId = req.getStorage('smallShop').id;
					merchantId = req.getStorage('smallShop').merchantDTO.id;
				}
			}
			route.share(1, req.getStorage('userInfo').id, path, merchantId, shopId, 1, this.query.id);
			// console.log(path);
			return {
				title: this.product.title,
				imageUrl: this.product.pic,
				path: path
			};
		},

		onReachBottom() {
			if (this.is_open_comments == 1 && this.tabIndex == 2) {
				this.form.page++;
				this.setData({
					['form.page']: this.form.page
				});
				// this.selectComponent("#list").loadScore(this.current);
				// console.log(this.form, "++++++++++++++++")
				this.$refs.list.loadScore(this.current, this.form);
			}
		},

		methods: {
			getBuyOrderMarquee(isToTime) {
				console.log('getBuyOrderMarquee数据获取>>>>>>');
				req.getRequest('/api/product/buyDynamic', {}, data => {
					this.isShowTime = true;
					this.buyOrderMarqueeList = data;
					if (isToTime) {
						if (this.buyOrderMarqueeList && this.buyOrderMarqueeList.length > 0) {
							this.marqueeOrderItem = this.buyOrderMarqueeList[this.marqueeOrderItemIndex];
							this.marqueeOrderItemIndex++;
							this.getMarqueeOrderItem();
						}
					}
				});
			},
			
			// 首页轮播最新购买记录
			getMarqueeOrderItem() {
				var tha = this;
				setTimeout(function() {
					// console.log('数据tha.marqueeOrderItemIndex>>>>', tha.marqueeOrderItemIndex);
					tha.marqueeOrderItem = tha.buyOrderMarqueeList[tha.marqueeOrderItemIndex];
					if (tha.marqueeOrderItemIndex >= tha.buyOrderMarqueeList.length - 1) {
						tha.marqueeOrderItemIndex = 0;
					} else {
						tha.marqueeOrderItemIndex++;
					}
			
					tha.getMarqueeOrderItem();
				}, 5000);
			},
			
			bindUser(par) {
				let userInfo = req.getStorage('userInfo');
				if (!userInfo) {
					// uni.login({
					// 	success(res) {
					// 		let params = {
					// 			code: res.code,
					// 		}
					// 		if(par.userId){
					// 			params.parentId = par.userId;
					// 		}
					// 		if(par.merchantId || par.shopId){
					// 			params.merchantId = par.merchantId ? par.merchantId : par.shopId ? par.shopId : ''
					// 		}
					// 		return new Promise((resolve, reject) => {
					// 			req.postRequest('/api/v2/login', params, data => {
					// 				resolve();
					// 			});
					// 		})
					// 	}
					// });
					// this.isPopupLogin = true;
					req.silenceLogin(par.userId, par.merchantId ? par.merchantId : par.shopId ? par.shopId : '');
				}
			},
			click(e) {
				// console.log(e,"7899")
				this.hideShare = e
			},
			getMerchant() {
				let that = this;
				api.getMerchant(this.query, req, data => {
					that.loadDefaultAddress();
					if (data == 1) {
						api.locationShow()
					} else {
						that.getuserInfo(data);
						if (req.getStorage('userInfo') && that.merchant.id != data.id) {
							if (data.type == 5) {
								that.query.merchantId = data.merchantDTO.id
								that.query.shopId = data.id
							} else {
								that.query.merchantId = data.id
							}
							this.loadProudct(this.query);
							let pages = getCurrentPages();
							var prevPage = pages[pages.length - 2];
							// console.log(prevPage, '++++++++++++++++++')
							if (prevPage) {
								prevPage.$vm.setData({
									freshen: true
								});
							}
						} else {
							this.loadProudct(this.query);
						}
						that.merchant = data

					}
				})
			},
			showShare() {
				// console.log(11111,this.hideShare)
				// #ifdef H5 
				this.setData({
					hideShare: false
				});

				// #endif
				// #ifndef H5
				req.isLogin().then(success => {
					// console.log(success)
					if (success) {
						this.getCodeUrl()
						this.setData({
							hideShare: false
						});
						// console.log(this.hideShare)
					}
				});
				// #endif
			},

			/**
			 * 轮播切换
			 */
			swiperChange({
				detail
			}) {
				if (this.current == 0 && this.swiperCurrent > 1) {
					//卡死时，重置current为正确索引
					this.setData({
						current: this.swiperCurrent
					});
				} else {
					//正常轮转时，记录正确页码索引
					this.setData({
						swiperCurrent: detail.current
					});
				}
			},

			dotEvent(e) {
				this.setData({
					current: e.currentTarget.dataset.current
				});
			},

			// 获取用户信息
			getuserInfo(data) {
				let that = this;
				let userInfo = req.getStorage('userInfo');
				// console.log(data, userInfo);
				if (userInfo && userInfo.listShopBase && userInfo.listShopBase != null && userInfo.listShopBase.length >
					0) {
					if (userInfo.listShopBase[0].merchant_id == data.id && data.type != 5) {
						let url = '/mine/shop/shop?merchantId=' + userInfo.listShopBase[0].merchant_id + '&shopId=' +
							userInfo.listShopBase[0].id;
						that.ascription = true;
						that.url = url
					}
					console.log('that.userInfo==' + that.userInfo)
				}
			},

			// 获取品质保证
			getGuarantee() {
				return new Promise((data, rej) => {
					req.getRequest('/api/config', {}, res => {
						req.setStorage('configRes', JSON.stringify(res))
						this.about = res
						data(res)
						if (!this.query.merchantId || this.merchant && this.merchant.isDefault == 1) {
							// 切割;拿到数组，然后在过滤掉空值
							if (res.b2c_service_guarantee && res.b2c_service_guarantee != null) {
								this.setData({
									guarantee: res.b2c_service_guarantee.split(";").filter(it => {
										return it = it && it.trim();
									})
								});
							}
						} else {
							if (res.o2o_service_guarantee && res.b2c_service_guarantee != null) {
								this.setData({
									guarantee: res.o2o_service_guarantee.split(";").filter(it => {
										return it = it && it.trim();
									})
								});
							}
						}

						if (res.show_membership_price) {
							this.setData({
								show_membership_price: res.show_membership_price
							});
						}

						if (res.Is_Store_Price_Stock) {
							this.setData({
								Is_Store_Price_Stock: res.Is_Store_Price_Stock
							});
						}

						if (res.is_open_shop) {
							this.setData({
								is_open_shop: res.is_open_shop
							});
						}

						if (res.is_open_comments) {
							this.setData({
								is_open_comments: res.is_open_comments
							});
						}
					});
				})
			},

			browsRecound(id) {
				let from = {
					bindId: id,
					type: 1,
					page: '/product/detail/detail?id=' + id
				};

				if (this.query.isShare) {
					from.shareType = 1;
					from.page = '/product/detail/detail?id=' + this.query.id + '&isShare=' + true;

					if (!this.query.userId) {} else {
						from.page += '&userId=' + this.query.userId;
					}

					if (!this.query.merchantId) {} else {
						from.merchantId = this.query.merchantId;
					}

					if (!this.query.shopId) {} else {
						from.shopId = this.query.shopId;
					}

					if (!this.query.userId) {} else {
						from.uid = this.query.userId;
					}
				}

				if (this.query.isShareTimeline) {
					from.shareType = 2;
					from.page = '/product/detail/detail?id=' + this.query.id + '&isShareTimeline=' + true;

					if (!this.query.userId) {} else {
						from.page += '&userId=' + this.query.userId;
					}

					if (!this.query.merchantId) {} else {
						from.merchantId = this.query.merchantId;
					}

					if (!this.query.shopId) {} else {
						from.shopId = this.query.shopId;
					}

					if (!this.query.userId) {} else {
						from.uid = this.query.userId;
					}
				}
				return new Promise((resolve,reject)=>{
					req.postRequest('/api/browse', from, data => {resolve()});
				})
			},

			govip() {
				uni.navigateTo({
					url: '/mine/vip/vip'
				});
			},

			loadCodeParams() {
				let _ts = this;

				return new Promise((resolve, reject) => {
					let form = {
						scene: _ts.scene
					};
					if (!_ts.scene) {
						resolve();
						return false;
					} // if (_ts.merchantId) {
					//   console.log("解析出来有门店")
					//   form.merchantId = _ts.merchantId
					// }


					req.getRequest('/api/code/params', form, data => {
						// console.log("====================================================================================" + data.merchantId)
						// this.data.query.id = data.scene;
						let res = data.scene.split('_');
						// console.log(res);
						this.query.id = res[0];
						this.query.merchantId = res[1];
						this.query.shopId = res[2]; // this.query.id = res[0];
						// this.query.merchantId = res[1];
						// this.query.shopId = res[2];

						if (res[1]) {
							this.setData({
								merchantId: res[1]
							});
						}

						if (res[2]) {
							this.setData({
								shopId: res[2]
							});
						}

						req.setStorage('pidCode', data.userId);
						let params = {
							merchantId: res[1],
							shopId: res[2],
							id: res[0],
							userId: data.userId
						};
						this.setData({
							params: params
						});
						resolve();
					});
				});
			},

			loadProudct(query) {
				let that = this;
				that.getMy();
				that.setData({
					bannerUrls: [],
					product: '',
					nodes: ''
				});
				// console.log(query.merchantId);
				let form = {
					id: query.id
				};
				if (query.merchantId) form.merchantId = query.merchantId;
				let isShowLoading = false;
				this.allShow = false
				if (!isShowLoading) {
					req.loadIng('加载中');
					isShowLoading = true;
				}
				let userInfo = req.getStorage('userInfo');
				if (userInfo.listShopBase && userInfo.listShopBase.length > 0) {
					form.shopId = userInfo.listShopBase[0].id;
				}
				req.getRequest('/api/product/detail', form, data => {
					//富文本图片放大
					var nodes = data.detail;
					// console.log(nodes)
					// if (nodes) {
					//   if (nodes.indexOf("src") >= 0) {
					//     //正则匹配所有图片路径
					//     var imgs = [];
					//     nodes = nodes.replace(/<img [^>]*src=['"]([^'"]+)[^>]*>/gi, function (match, capture) {
					//       imgs.push(capture);
					//       that.setData({
					//         imgs: imgs
					//       });
					//       return '';
					//     });
					//   }
					// }

					if (data.isOtc == 5) {
						uni.setNavigationBarTitle({
							title: '海外购'
						});
					}

					// console.log(this
					// 	.Is_Store_Price_Stock); // if (data.stock <= 0 && this.data.Is_Store_Price_Stock == 1) {
					//   req.msgConfirm("该门店产品库存不足，请切换其他门店购买", success => {
					//     this.updateShop(1)
					//     //  this.query.merchantId=this.data.merchantId
					//   }, cancel => { })
					// }

					let tabe = [];
					let propertiesList = []
					if (data.propertiesList && data.propertiesList.length > 0) {
						data.propertiesList.map(it => {
							propertiesList.push(it.value);
						})
					}
					data.properties = propertiesList.join(' / ')
					if (data.deliverWay != null) {
						let arr = ['自提', '邮寄', '同城配送',
							'自主配送'
						]; // console.log(data.deliverWay.split(','),JSON.parse(data.deliverWay));

						let deliverWay = JSON.parse(data.deliverWay);
						deliverWay.forEach(it => {
							tabe.push(arr[it - 1]);
						});
						if (deliverWay.indexOf(3) != -1) data.isJs = true;
					}

					// console.log(tabe, data);
					that.setData({
						bannerUrls: data.images,
						product: data,
						nodes: nodes,
						tabe: tabe,
						load: true,
						allShow: true
					});

					if (isShowLoading) {
						uni.hideLoading();
						isShowLoading = false;
					}
					if (data.membersPrice && data.actualPrice < data.salePrice) {
						let jian = parseFloat(data.salePrice - data.actualPrice).toFixed(2);
						this.setData({
							['product.jianMoney']: jian
						});
					}

					if (data.membersPrice && data.membersPrice < data.salePrice) {
						let jian = parseFloat(data.salePrice - data.membersPrice).toFixed(2);
						this.setData({
							['product.jianMoney']: jian
						});
					} // if (data.detail) {
					//   this.setData({ detail: data.detail.replace(/\<img/gi, '<img class="rich-img"') })
					// }
					// that.getCodeUrl();

				});
			},
			getMy() {
				let that = this;
				let userInfo = req.getStorage('userInfo');
				if (!userInfo || userInfo == null) return false;
				req.getRequest('/api/user/my', {}, data => {
					that.userInfo = data;
					that.isDistriUser = data.isDistriUser;
				});
			},

			getCodeUrl() {
				let that = this;
				let scene = that.product.id;
				if (req.getStorage('MERCHANT') && req.getStorage('MERCHANT').id != null) {
					scene += '_' + req.getStorage('MERCHANT').id;
					if (req.getStorage('smallShop') && req.getStorage('MERCHANT').id != null) {
						scene += '_' + req.getStorage('smallShop').id;
					}
				}
				// console.log(scene); //获取小程序码
				const params = {
					page: 'product/detail/detail',
					scene: scene
				};
				req.getRequest('/api/program/codev', params, url => {
					that.setData({
						codeUrl: url
					});
				});
			},

			loadDefaultAddress() {
				if (req.isAuth()) {
					req.g('/api/address/default', data => {
						if (data) this.setData({
							address: data
						});
						else this.pointLocation();
					}, true);
				} else {
					this.pointLocation();
				}
			},

			pointLocation() {
				//定位当前位置
				let _ts = this;

				QQMapWX.initMap();
				req.getLocation(res => {
					QQMapWX.reverseGeocoder(res, data => {
						_ts.setData({
							['address.address']: data.address
						});
					});
				});
			},

			toAddress() {
				this.changeFreshen()
				app.globalData.openPage('mine/address/address');
			},

			atOnceBuy() {
				// console.log(this.merchantId);
				if(this.isVideoScene && !req.getStorage('userInfo')){
					this.bindUser()
					return false;
				}
				if(!req.getStorage('userInfo').mobile) {
					this.isShowUpdate = true;
					this.isUpdateMobile = true;
					return false;
				}
				if (!this.query.merchantId) this.setData({
					index: 'index'
				});
				this.setData({
					isShow: true,
					isCart: false,
					popup: this.product
				});
			},

			onActive() {
				this.setData({
					isActive: true
				});
			},

			addShopCart() {
				if(this.isVideoScene && !req.getStorage('userInfo')){
					this.bindUser()
					return false;
				}
				if(!req.getStorage('userInfo').mobile) {
					this.isShowUpdate = true;
					this.isUpdateMobile = true;
					return false;
				}
				if (!this.query.merchantId) this.setData({
					index: 'index'
				});
				this.setData({
					isShow: true,
					isCart: true,
					popup: this.product
				});
			},

			hidePopup() {
				this.setData({
					isShow: false
				});
			},
			changeFreshen(){
				this.freshen = false;
			},
			hidePopupLogin(data) {
				this.isPopupLogin = false;
			},

			hideActive() {
				this.setData({
					isActive: false
				});
			},

			addCartSuccess(event) {
				this.setData({
					'product.count': parseInt(this.product.count) + parseInt(event.detail.quantity),
					isShow: false
				});
			},

			clickCollect() {
				let _ts = this;

				req.postRequest('/api/collect', {
					bindId: this.product.id,
					type: 1
				}, data => {
					_ts.setData({
						'product.isCollect': !_ts.product.isCollect
					});
				});
			},

			goTop: function(e) {
				// 一键回到顶部
				if (uni.pageScrollTo) {
					uni.pageScrollTo({
						scrollTop: 0
					});
				} else {
					uni.showModal({
						title: '提示',
						content: '当前微信版本过低，无法使用该功能，请升级到最新微信版本后重试。'
					});
				}
			},

			onShareTimeline() {
				let merchantId = '';
				let path = 'id=' + this.query.id + '&isShareTimeline=' + true;

				if (!req.getStorage('userInfo').id) {} else {
					path += '&userId=' + req.getStorage('userInfo').id;
				}

				// console.log(this.query.merchantId);
				let shopId = '';

				if (!this.query.merchantId) {
					// console.log(123, path);
				} else {
					if (req.getStorage('MERCHANT') && req.getStorage('MERCHANT').id != null) {
						path += '&merchantId=' + req.getStorage('MERCHANT').id;
						merchantId = req.getStorage('MERCHANT').id;

						if (req.getStorage('smallShop') && req.getStorage('MERCHANT').id != null) {
							path += '&shopId=' + req.getStorage('smallShop').id;
							shopId = req.getStorage('smallShop').id;
							merchantId = req.getStorage('smallShop').merchantDTO.id;
						}
					}
				}

				let url = '/product/detail/detail?' + path;
				route.share(2, req.getStorage('userInfo').id, url, merchantId, shopId, 1, this.query.id);
				// console.log(path, url);
				return {
					title: this.product.title,
					query: path,
					imageUrl: this.product.images[0]
				};
			},

			// 选择服务门店
			updateShop(type) {

				let url = 'pages/nearby/nearby?isChoose=true';

				if (type == 1) {
					url += '&type=' + type;
				}

				if (this.about.User_Limit_Store == 1) {

				} else {
					app.globalData.openPage(url);
				}
			},

			onHide() {
				this.setData({
					load: false
				})
			},

			// 是否开启小店
			isShop() {
				if (req.getStorage('distribution')) {
					let dist = req.getStorage('distribution')
					this.setData({
						distr: dist
					})
					console.log(dist)
					if (dist.distributionSmallShopOpen == 1) {
						req.postRequest('/api/shopBase/isOpenShop', {}, data => {
							this.setData({
								isshop: data
							})
							console.log(data)
						})
					}
				}
			},
			addShop() {
				//添加到小店
				req.postRequest('/api/shopProduct/save', {
					productId: this.product.id,
					type: 1
				}, data => {
					// console.log(data);
					this.setData({
						isHide: false
					});
					this.product.isJoinShop = true;
				});
			},

			hidePop() {
				//添加到小店
				this.setData({
					isHide: true
				});
			},

			showTab: function(e) {
				this.setData({
					tabIndex: e.detail
				});
			},
			scoreTab: function(e) {
				this.form.page = 0;
				this.setData({
					current: e.detail,
					['form.page']: 1
				});
			},
			freshenFun: function(e) {
				this.setData({
					freshen: e.detail
				});
			},
			getForm: function(e) {
				// console.log(e.detail,"qqqqq")
				this.form.page = e.detail
			},
			getPor: function(e) {
				// console.log(e.detail, "qqqqq")
				this.popup = e.detail
				this.product = e.detail
			},
			getProductCoupon(){
				let form = {
					page: 1,
					limit: 3,
					productId: this.query.id
				}
				return new Promise((resolve,reject)=>{
					req.getRequest('/api/coupon/listV2',form,data=>{
						this.couponList = data;
						resolve();
					})
				})
			},
			jumpUrl(url){
				this.changeFreshen()
				uni.navigateTo({
					url: url
				})
			},
			closeUpdate(){
				this.isShowUpdate = false
			},
			updateInfo(e){
				this.isUpdateInfo = e
			},
			updateMobile(e){
				this.isUpdateMobile = e
			},
		}
	};
</script>
<style>
	@import "./detail.css";
</style>
